
package com.bluebamboostudios;

import android.content.ContentResolver;
import android.Manifest;
import android.app.Activity;
import android.support.v4.app.ActivityCompat;
import android.support.annotation.NonNull;
import android.support.v4.content.PermissionChecker;

import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.Promise;

public class RNContactsPickerModule extends ReactContextBaseJavaModule {
    public static final String PERMISSION_READ_CONTACTS = Manifest.permission.READ_CONTACTS;
    public static final int PERMISSION_READ_CONTACTS_REQUEST_CODE = 30156;

    private final ReactApplicationContext reactContext;
    private final ContentResolver contentResolver;

    private static Promise mPromise;

    public RNContactsPickerModule(ReactApplicationContext reactContext) {
        super(reactContext);
        this.contentResolver = getReactApplicationContext().getContentResolver();
        this.reactContext = reactContext;
    }

    @Override
    public String getName() {
        return "ContactsPicker";
    }

    @ReactMethod
    public void hasAccess(Promise promise) {
        promise.resolve(accessGranted());
    }

    @ReactMethod
    public void requestAccess(Promise promise) {
        if (accessGranted()) {
            promise.resolve(true);
            return;
        }

        mPromise = promise;

        Activity currentActivity = getCurrentActivity();
        ActivityCompat.requestPermissions(currentActivity, new String[]{PERMISSION_READ_CONTACTS}, PERMISSION_READ_CONTACTS_REQUEST_CODE);
    }


    @ReactMethod
    public void pickContact(Promise reactPromise) {


    }

    protected static void onRequestPermissionResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResult) {
        if (requestCode == PERMISSION_READ_CONTACTS_REQUEST_CODE && PERMISSION_READ_CONTACTS.equals(permissions[0])) {
            if (mPromise != null) {
                mPromise.resolve(grantResult[0] == PermissionChecker.PERMISSION_GRANTED);
            }
        }
    }

    private boolean accessGranted() {
        final int status = PermissionChecker.checkCallingOrSelfPermission(getReactApplicationContext(), PERMISSION_READ_CONTACTS);

        if (status == PermissionChecker.PERMISSION_GRANTED) {
            return true;
        } else {
            return false;
        }
    }
}